diff --git a/src/main/java/net/minecraft/core/world/type/WorldType.java b/src/main/java/net/minecraft/core/world/type/WorldType.java
index 497061c63..ca65452c2 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -1,114 +1,159 @@
 package net.minecraft.core.world.type;
 
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.Global;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.wind.WindManager;
+import net.minecraft.core.world.weather.Weathers;
+import net.minecraft.core.world.wind.WindProvider;
+import net.minecraft.core.world.wind.WindProviderGeneric;
 
-public abstract class WorldType
-{
+public abstract class WorldType {
     private final String languageKey;
     private final Weather defaultWeather;
-    private final WindManager windManager;
+    private final WindProvider windProvider;
     private final boolean hasCeiling;
     private final float[] brightnessRamp;
-    private final SeasonConfig defaultSeasonConfig;
-
-    public WorldType(String languageKey, Weather defaultWeather, WindManager windManager, boolean hasCeiling, float[] brightnessRamp, SeasonConfig defaultSeasonConfig)
-    {
-        this.languageKey = languageKey;
-        this.defaultWeather = defaultWeather;
-        this.windManager = windManager;
-        this.hasCeiling = hasCeiling;
-        this.brightnessRamp = brightnessRamp;
-        this.defaultSeasonConfig = defaultSeasonConfig;
+    private final SeasonConfig seasonConfig;
+    private final boolean hasClouds;
+    private final boolean hasSky;
+    private final int minY;
+    private final int maxY;
+    private final int oceanY;
+    private final int oceanBlockId;
+    private final int fillerBlockId;
+    private final int dayNightCycleTicks;
+    private final boolean mayRespawn;
+    private final float cloudHeight;
+    private final boolean hasGround;
+    private final boolean hasAurora;
+
+    public WorldType(Properties properties) {
+        this.languageKey = properties.languageKey;
+        this.defaultWeather = properties.defaultWeather == null ? Weathers.OVERWORLD_CLEAR : properties.defaultWeather;
+        this.windProvider = properties.windProvider == null ? new WindProviderGeneric() : properties.windProvider;
+        this.hasCeiling = properties.hasCeiling;
+        this.brightnessRamp = properties.brightnessRamp;
+        this.seasonConfig = properties.seasonConfig == null ? SeasonConfig.builder().withSingleSeason(Seasons.NULL).build() : properties.seasonConfig;
+        this.hasClouds = properties.hasClouds;
+        this.hasSky = properties.hasSky;
+        this.minY = properties.minY;
+        this.maxY = properties.maxY;
+        this.oceanY = properties.oceanY;
+        this.oceanBlockId = properties.oceanBlock == null ? 0 : properties.oceanBlock.id;
+        this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id;
+        this.dayNightCycleTicks = properties.dayNightCycleTicks;
+        this.mayRespawn = properties.mayRespawn;
+        this.cloudHeight = properties.cloudHeight == null ? (properties.maxY + 1) - 20 : properties.cloudHeight;
+        this.hasGround = properties.hasGround;
+        this.hasAurora = properties.hasAurora;
     }
 
-    public void onWorldCreation(World world) { }
-
-    public String getLanguageKey()
-    {
+    public String getLanguageKey() {
         return languageKey;
     }
 
-    public Weather getDefaultWeather()
-    {
+    public Weather getDefaultWeather() {
         return defaultWeather;
     }
 
-    public WindManager getWindManager()
-    {
-        return windManager;
+    public WindProvider getWindManager() {
+        return windProvider;
     }
 
-    public boolean hasCeiling()
-    {
+    public boolean hasCeiling() {
         return hasCeiling;
     }
 
-    public float[] getBrightnessRamp()
-    {
+    public float[] getBrightnessRamp() {
         return brightnessRamp;
     }
 
-    public SeasonConfig getDefaultSeasonConfig()
-    {
-        return defaultSeasonConfig;
+    public SeasonConfig getSeasonConfig() {
+        return seasonConfig;
     }
 
     public boolean hasClouds() {
-        return true;
+        return hasClouds;
     }
 
     public boolean hasSky() {
-        return true;
+        return hasSky;
+    }
+
+    public int getMinY() {
+        return minY;
+    }
+
+    public int getMaxY() {
+        return maxY;
+    }
+
+    public int getOceanY() {
+        return oceanY;
+    }
+
+    public int getOceanBlockId() {
+        return oceanBlockId;
+    }
+
+    public int getFillerBlockId() {
+        return fillerBlockId;
+    }
+
+    public int getDayNightCycleTicks() {
+        return dayNightCycleTicks;
+    }
+
+    public boolean mayRespawn() {
+        return mayRespawn;
+    }
+
+    public float getCloudHeight() {
+        return cloudHeight;
+    }
+
+    public boolean hasGround() {
+        return hasGround;
     }
 
-    public abstract int getMinY();
+    public boolean hasAurora() {
+        return hasAurora;
+    }
 
-    public abstract int getMaxY();
+    public void onWorldCreation(World world) { }
 
-    public final int getYRange()
-    {
+    public final int getYRange() {
         return getMaxY() - getMinY();
     }
 
-    public final double getYPercentage(int y)
-    {
+    public final double getYPercentage(int y) {
         int range = getYRange();
         y -= getMinY();
         return (double)y / (double)range;
     }
 
-    public abstract int getOceanY();
-
-    public abstract int getOceanBlock();
-
-    public abstract int getFillerBlock();
-
     public abstract BiomeProvider createBiomeProvider(World world);
 
     public abstract ChunkGenerator createChunkGenerator(World world);
 
     public abstract boolean isValidSpawn(World world, int x, int y, int z);
 
-    public void getInitialSpawnLocation(World world)
-    {
+    public void getInitialSpawnLocation(World world) {
         int x = 0;
         int y = 0;
         int z = 0;
-        spawnLoop:  while (true)
-        {
+        spawnLoop:  while (true) {
             x += world.rand.nextInt(64) - world.rand.nextInt(64);
             z += world.rand.nextInt(64) - world.rand.nextInt(64);
-            for (y = getMaxY(); y >= getMinY(); y--)
-            {
-                if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z))
-                {
+            for (y = getMaxY(); y >= getMinY(); y--) {
+                if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
                     break spawnLoop;
                 }
             }
@@ -116,17 +161,14 @@ public abstract class WorldType
         world.getLevelData().setSpawn(x, y, z);
     }
 
-    public void getRespawnLocation(World world)
-    {
+    public void getRespawnLocation(World world) {
         LevelData levelData = world.getLevelData();
-        if(levelData.getSpawnY() <= 0)
-        {
+        if(levelData.getSpawnY() <= 0) {
             levelData.setSpawnY(getOceanY());
         }
         int x = levelData.getSpawnX();
         int z = levelData.getSpawnZ();
-        while (world.getTopBlock(x, z) == 0)
-        {
+        while (world.getTopBlock(x, z) == 0) {
             x += world.rand.nextInt(8) - world.rand.nextInt(8);
             z += world.rand.nextInt(8) - world.rand.nextInt(8);
         }
@@ -136,40 +178,34 @@ public abstract class WorldType
 
     }
 
-    public abstract int getDayNightCycleLengthTicks();
-
     protected int getDayLengthTicks(World world) {
         float dayLength;
         float seasonProgress = world.getSeasonManager().getSeasonProgress();
-        if (seasonProgress < 0.5f)
-        {
+        if (seasonProgress < 0.5f) {
             float lastSeasonDayLength = world.getSeasonManager().getPreviousSeason().dayLength;
             float thisSeasonDayLength = world.getSeasonManager().getCurrentSeason().dayLength;
             float seasonModifier = world.getSeasonManager().getSeasonModifier() * 0.5f + 0.5f;
             dayLength = (lastSeasonDayLength * (1.0f - seasonModifier)) + (thisSeasonDayLength * seasonModifier);
-        }
-        else
-        {
+        } else {
             float thisSeasonDayLength = world.getSeasonManager().getCurrentSeason().dayLength;
             float nextSeasonDayLength = world.getSeasonManager().getNextSeason().dayLength;
             float seasonModifier = world.getSeasonManager().getSeasonModifier() * 0.5f + 0.5f;
             dayLength = (thisSeasonDayLength * seasonModifier) + (nextSeasonDayLength * (1.0f - seasonModifier));
         }
 
-        int cycleTicks = getDayNightCycleLengthTicks();
+        int cycleTicks = getDayNightCycleTicks();
         return (int)(dayLength * cycleTicks);
     }
 
     public int getSunriseTick(World world) {
         int dayLengthTicks = getDayLengthTicks(world);
-        int cycleTicks = getDayNightCycleLengthTicks();
+        int cycleTicks = getDayNightCycleTicks();
         return cycleTicks / 4 - dayLengthTicks / 2;
     }
 
-    public float getTimeOfDay(World world, long tick, float partialTick)
-    {
+    public float getTimeOfDay(World world, long tick, float partialTick) {
         tick += 18000;
-        int cycleTicks = getDayNightCycleLengthTicks();
+        int cycleTicks = getDayNightCycleTicks();
         int dayTicks = getDayLengthTicks(world);
         int nightTicks = cycleTicks - dayTicks;
 
@@ -198,16 +234,125 @@ public abstract class WorldType
 
     public abstract int getSkyDarken(World world, long tick, float partialTick);
 
-    public abstract Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick);
+    public abstract Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick);
+
+    public static class Properties {
+        private final String languageKey;
+        private Weather defaultWeather = null;
+        private WindProvider windProvider = null;
+        private boolean hasCeiling = false;
+        private float[] brightnessRamp = null;
+        private SeasonConfig seasonConfig = null;
+        private boolean hasClouds = true;
+        private boolean hasSky = true;
+        private int minY = 0;
+        private int maxY = 255;
+        private int oceanY = 128;
+        private Block oceanBlock = null;
+        private Block fillerBlock = null;
+        private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
+        private boolean mayRespawn = false;
+        private Float cloudHeight = null;
+        private boolean hasGround = true;
+        private boolean hasAurora = false;
+
+        private Properties(String languageKey) {
+            this.languageKey = languageKey;
+        }
+
+        public static Properties of(String languageKey) {
+            return new Properties(languageKey);
+        }
+
+        public Properties defaultWeather(Weather weather) {
+            this.defaultWeather = weather;
+            return this;
+        }
+
+        public Properties windManager(WindProvider windProvider) {
+            this.windProvider = windProvider;
+            return this;
+        }
+
+        public Properties withCeiling() {
+            this.hasCeiling = true;
+            return this;
+        }
+
+        public Properties brightnessRamp(float[] brightnessRamp) {
+            this.brightnessRamp = brightnessRamp;
+            return this;
+        }
+
+        public Properties seasonConfig(SeasonConfig seasonConfig) {
+            this.seasonConfig = seasonConfig;
+            return this;
+        }
+
+        public Properties noClouds() {
+            this.hasClouds = false;
+            return this;
+        }
+
+        public Properties noSky() {
+            this.hasSky = false;
+            return this;
+        }
+
+        public Properties bounds(int minY, int maxY, int oceanY) {
+            if (minY < 0) {
+                throw new IllegalArgumentException("minY cannot be negative");
+            }
+            if (maxY < 0) {
+                throw new IllegalArgumentException("maxY cannot be negative");
+            }
+            if (maxY <= minY) {
+                throw new IllegalArgumentException("maxY cannot be less than or equal to minY");
+            }
+            if (oceanY < 0) {
+                throw new IllegalArgumentException("oceanY cannot be negative");
+            }
+
+            this.minY = minY;
+            this.maxY = maxY;
+            this.oceanY = oceanY;
+
+            return this;
+        }
+
+        public Properties oceanBlock(Block oceanBlock) {
+            this.oceanBlock = oceanBlock;
+            return this;
+        }
+
+        public Properties fillerBlock(Block fillerBlock) {
+            this.fillerBlock = fillerBlock;
+            return this;
+        }
+
+        public Properties dayNightCycleTicks(int ticks) {
+            this.dayNightCycleTicks = ticks;
+            return this;
+        }
 
-    public abstract boolean mayRespawn();
+        public Properties allowRespawn() {
+            this.mayRespawn = true;
+            return this;
+        }
 
-    public abstract float getCloudHeight();
+        public Properties cloudHeight(float cloudHeight) {
+            this.cloudHeight = cloudHeight;
+            return this;
+        }
 
-    public abstract boolean hasGround();
+        public Properties noGround() {
+            this.hasGround = false;
+            return this;
+        }
 
-    public boolean hasAurora()
-    {
-        return false;
+        public Properties withAurora() {
+            this.hasAurora = true;
+            return this;
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java b/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
index 9685e4b79..8fd2f3edb 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
@@ -1,142 +1,68 @@
 package net.minecraft.core.world.type;
 
-import net.minecraft.core.Global;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
-import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.debug.ChunkGeneratorDebug;
-import net.minecraft.core.world.season.Seasons;
-import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.wind.WindManagerGeneric;
 
 import java.util.Arrays;
 
 public class WorldTypeDebug
-    extends WorldType
-{
-    public WorldTypeDebug(String languageKey) {
-        super(
-            languageKey,
-            Weather.overworldClear,
-            new WindManagerGeneric(),
-            false,
-            createLightRamp(),
-            SeasonConfig.builder()
-                .withSingleSeason(Seasons.NULL)
-                .build()
-        );
+        extends WorldType {
+    public WorldTypeDebug(Properties properties) {
+        super(properties);
     }
 
-    private static float[] createLightRamp()
-    {
+    public static float[] createLightRamp() {
         float[] brightnessRamp = new float[32];
         Arrays.fill(brightnessRamp, 1.0f);
         return brightnessRamp;
     }
 
     @Override
-    public int getMinY()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getMaxY()
-    {
-        return 255;
-    }
-
-    @Override
-    public int getOceanY()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getOceanBlock()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getFillerBlock()
-    {
-        return 0;
-    }
-
-    @Override
-    public BiomeProvider createBiomeProvider(World world)
-    {
+    public BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
     @Override
-    public ChunkGenerator createChunkGenerator(World world)
-    {
+    public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorDebug(world);
     }
 
     @Override
-    public boolean isValidSpawn(World world, int x, int y, int z)
-    {
+    public boolean isValidSpawn(World world, int x, int y, int z) {
         return true;
     }
 
     @Override
-    public void getInitialSpawnLocation(World world)
-    {
+    public void getInitialSpawnLocation(World world) {
         world.getLevelData().setSpawn(0, 1, 0);
     }
 
     @Override
-    public void getRespawnLocation(World world) { }
-
-    @Override
-    public int getDayNightCycleLengthTicks()
-    {
-        return Global.DAY_LENGTH_TICKS;
+    public void getRespawnLocation(World world) {
     }
 
     @Override
-    public float getCelestialAngle(World world, long tick, float partialTick)
-    {
+    public float getCelestialAngle(World world, long tick, float partialTick) {
         return 0;
     }
 
     @Override
-    public float[] getSunriseColor(float timeOfDay, float partialTick)
-    {
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
         return new float[4];
     }
 
     @Override
-    public int getSkyDarken(World world, long tick, float partialTick)
-    {
+    public int getSkyDarken(World world, long tick, float partialTick) {
         return 0;
     }
 
     @Override
-    public Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick)
-    {
-        return Vec3d.createVector(1.0, 1.0, 1.0);
-    }
-
-    @Override
-    public boolean mayRespawn() {
-        return true;
-    }
-
-    @Override
-    public float getCloudHeight() {
-        return 108.0f;
-    }
-
-    @Override
-    public boolean hasGround() {
-        return false;
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        return Vec3.getTempVec3(1.0, 1.0, 1.0);
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java b/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
index 9405e52a0..b18d77fc4 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
@@ -1,42 +1,26 @@
 package net.minecraft.core.world.type;
 
-import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
-import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.empty.ChunkGeneratorEmpty;
-import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
-import net.minecraft.core.world.wind.WindManagerGeneric;
 
 public class WorldTypeEmpty
-    extends WorldType
-{
-    public WorldTypeEmpty(String languageKey) {
-        super(
-            languageKey,
-            Weather.overworldClear,
-            new WindManagerGeneric(),
-            false,
-            createLightRamp(),
-            SeasonConfig.builder()
-                .withSingleSeason(Seasons.NULL)
-                .build()
-        );
+        extends WorldType {
+    public WorldTypeEmpty(Properties properties) {
+        super(properties);
     }
 
-    private static float[] createLightRamp()
-    {
+    public static float[] createLightRamp() {
         float[] brightnessRamp = new float[32];
         float f = 0.05F;
-        for(int i = 0; i <= 31; i++)
-        {
-            float f1 = 1.0F - (float)i / 15F;
+        for (int i = 0; i <= 31; i++) {
+            float f1 = 1.0F - (float) i / 15F;
             if (i > 15) f1 = 0.0f;
             brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
         }
@@ -44,127 +28,78 @@ public class WorldTypeEmpty
     }
 
     @Override
-    public int getMinY()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getMaxY()
-    {
-        return 255;
-    }
-
-    @Override
-    public int getOceanY()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getOceanBlock()
-    {
-        return 0;
-    }
-
-    @Override
-    public int getFillerBlock()
-    {
-        return 0;
-    }
-
-    @Override
-    public BiomeProvider createBiomeProvider(World world)
-    {
+    public BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
     @Override
-    public ChunkGenerator createChunkGenerator(World world)
-    {
+    public ChunkGenerator createChunkGenerator(World world) {
         return new ChunkGeneratorEmpty(world);
     }
 
     @Override
-    public boolean isValidSpawn(World world, int x, int y, int z)
-    {
+    public boolean isValidSpawn(World world, int x, int y, int z) {
         return true;
     }
 
     @Override
-    public void getInitialSpawnLocation(World world)
-    {
+    public void getInitialSpawnLocation(World world) {
         world.getLevelData().setSpawn(0, 1, 0);
     }
 
     @Override
-    public void getRespawnLocation(World world) { }
-
-    @Override
-    public int getDayNightCycleLengthTicks()
-    {
-        return Global.DAY_LENGTH_TICKS;
+    public void getRespawnLocation(World world) {
     }
 
     @Override
-    public float getCelestialAngle(World world, long tick, float partialTick)
-    {
+    public float getCelestialAngle(World world, long tick, float partialTick) {
         return getTimeOfDay(world, tick, partialTick);
     }
 
     @Override
-    public float[] getSunriseColor(float timeOfDay, float partialTick)
-    {
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
         float[] sunriseCol = new float[4];
         float f2 = 0.4F;
-        float f3 = MathHelper.cos(timeOfDay * 3.141593F * 2.0F) - 0.0F;
+        float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
         float f4 = -0F;
-        if(f3 >= f4 - f2 && f3 <= f4 + f2)
-        {
+        if (f3 >= f4 - f2 && f3 <= f4 + f2) {
             float c = ((f3 - f4) / f2) * 0.5F + 0.5F;
-            float a = 1.0F - (1.0F - MathHelper.sin(c * 3.141593F)) * 0.99F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
             a *= a;
             sunriseCol[0] = c * 0.3F + 0.7F;
             sunriseCol[1] = c * c * 0.7F + 0.2F;
             sunriseCol[2] = c * c * 0.0F + 0.2F;
             sunriseCol[3] = a;
             return sunriseCol;
-        }
-        else
-        {
+        } else {
             return null;
         }
     }
 
     @Override
-    public int getSkyDarken(World world, long tick, float partialTick)
-    {
+    public int getSkyDarken(World world, long tick, float partialTick) {
         float f1 = getCelestialAngle(world, tick, partialTick);
-        float f2 = 1.0F - (MathHelper.cos(f1 * 3.141593F * 2.0F) * 2.0F + 0.5F);
-        if(f2 < 0.0F)
-        {
+        float f2 = 1.0F - (MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F);
+        if (f2 < 0.0F) {
             f2 = 0.0F;
         }
-        if(f2 > 1.0F)
-        {
+        if (f2 > 1.0F) {
             f2 = 1.0F;
         }
         float weatherOffset = 0;
         Weather currentWeather = world.getCurrentWeather();
-        if (currentWeather != null) weatherOffset = currentWeather.subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
-        return (int)(f2 * (11F - weatherOffset) + weatherOffset);
+        if (currentWeather != null)
+            weatherOffset = currentWeather.subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+        return (int) (f2 * (11F - weatherOffset) + weatherOffset);
     }
 
     @Override
-    public Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick)
-    {
-        float f2 = MathHelper.cos(celestialAngle * 3.141593F * 2.0F) * 2.0F + 0.5F;
-        if(f2 < 0.0F)
-        {
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        if (f2 < 0.0F) {
             f2 = 0.0F;
         }
-        if(f2 > 1.0F)
-        {
+        if (f2 > 1.0F) {
             f2 = 1.0F;
         }
         float r = 0.7529412F;
@@ -173,20 +108,6 @@ public class WorldTypeEmpty
         r *= f2 * 0.94F + 0.06F;
         g *= f2 * 0.94F + 0.06F;
         b *= f2 * 0.91F + 0.09F;
-        return Vec3d.createVector(r, g, b);
-    }
-    @Override
-    public boolean mayRespawn() {
-        return true;
-    }
-
-    @Override
-    public float getCloudHeight() {
-        return 108.0f;
-    }
-
-    @Override
-    public boolean hasGround() {
-        return false;
+        return Vec3.getTempVec3(r, g, b);
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java b/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
new file mode 100644
index 000000000..c5b57133a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeGroups.java
@@ -0,0 +1,85 @@
+package net.minecraft.core.world.type;
+
+import net.minecraft.core.world.Dimension;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class WorldTypeGroups {
+    public static final List<Group> GROUPS = new ArrayList<>();
+    public static final Group DEFAULT = new Group(WorldTypes.OVERWORLD_EXTENDED);
+
+    static {
+        GROUPS.add(
+            DEFAULT
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_DEFAULT)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_WINTER)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_FLOATING)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_AMPLIFIED)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_ISLANDS)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_INLAND)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.FLAT)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_HELL)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_WOODS)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_PARADISE)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_CLASSIC)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_INDEV)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_RETRO)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.OVERWORLD_SKYBLOCK)
+                .with(Dimension.nether, WorldTypes.NETHER_SKYBLOCK)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.EMPTY)
+        );
+        GROUPS.add(
+            new Group(WorldTypes.DEBUG)
+        );
+    }
+
+    public static class Group {
+        private final Map<Dimension, WorldType> worldTypes = new HashMap<>();
+
+        public Group(WorldType overworldType) {
+            worldTypes.put(Dimension.overworld, overworldType);
+        }
+
+        public Group with(Dimension dimension, WorldType worldType) {
+            worldTypes.put(dimension, worldType);
+            return this;
+        }
+
+        public WorldType get(Dimension dimension) {
+            return worldTypes.get(dimension);
+        }
+    }
+}
